import React from 'react';
import type { ReactNode } from 'react';
import type { IItemBase, Edge } from '@antv/g6';
declare type Props = {
    currentItem: IItemBase | null;
    name: ReactNode;
    graph?: any;
    options?: {
        onOk?: (item: {
            source: string;
            target: string;
        }) => void;
    };
};
declare class AddRelation extends React.PureComponent<Props> {
    static defaultProps: {
        options: {
            onOk: () => void;
        };
    };
    dragging: Edge | null;
    onOk: () => void;
    dragEdge: (e: any) => void;
    drop: (e: any) => void;
    cancelAdding: () => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    handleAddRelation: () => void;
    render(): JSX.Element;
}
export default AddRelation;
