import React, { ReactNode } from 'react';
interface Props {
    type: 'node' | 'edge';
    itemData: any;
    id: string;
    visible: boolean;
    nodeProperties: object;
    edgeProperties: object;
    nodeTypes: TypeInfo[];
    edgeTypes: TypeInfo[];
    saveItem: (type: 'node' | 'edge', data: any) => void;
    onClose: () => void;
}
export declare type TypeInfo = {
    key: string;
    content: ReactNode;
    text?: string;
    typeName?: string;
    sourceNodeType?: string;
    targetNodeType?: string;
};
declare const EditDrawer: React.FC<Props>;
export default EditDrawer;
