"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.locale = exports.default = exports.MappingWay = exports.ITEM_STATE = void 0;
var _giSdk = require("@antv/gi-sdk");
var _info = _interopRequireDefault(require("./info"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var locale = {
  degree: '度中心性',
  'degree-tip': '根据实体的出入度大小计算',
  'page-rank': 'PageRank网页排序',
  'page-rank-tip': '使用PageRank网页排序算法计算',
  'node-property': '节点属性重要性',
  'node-property-tip': '根据节点属性值计算',
  'edge-property': '关系属性重要性',
  'edge-property-tip': '根据节点相关关系的属性计算',
  'in-degree': '入度',
  'out-degree': '出度',
  ave: '平均数',
  min: '最小值',
  max: '最大值',
  median: '中位数',
  sort: '排序',
  'sort-tip': '适用于数值型',
  count: '计数',
  'count-tip': '适用于枚举型',
  'positive-correlation': '正相关',
  'positive-tip': '值越大，点或边越大',
  'negative-correlation': '正相关',
  'negative-tip': '值越小，点或边越大'
};
exports.locale = locale;
var MappingWay;
exports.MappingWay = MappingWay;
(function (MappingWay) {
  MappingWay["Positive"] = "positive";
  MappingWay["Negative"] = "negative";
})(MappingWay || (exports.MappingWay = MappingWay = {}));
var ITEM_STATE;
exports.ITEM_STATE = ITEM_STATE;
(function (ITEM_STATE) {
  ITEM_STATE["Active"] = "active";
  ITEM_STATE["Default"] = "default";
  ITEM_STATE["Selected"] = "selected";
  ITEM_STATE["Disable"] = "disable";
  ITEM_STATE["Highlight"] = "highlight";
  ITEM_STATE["Inactive"] = "inactive";
})(ITEM_STATE || (exports.ITEM_STATE = ITEM_STATE = {}));
var GIAC_CONTENT_METAS = _giSdk.extra.GIAC_CONTENT_METAS,
  deepClone = _giSdk.extra.deepClone;
var metas = deepClone(GIAC_CONTENT_METAS);
metas.GIAC_CONTENT.properties.GIAC_CONTENT.properties.title.default = _info.default.name;
metas.GIAC_CONTENT.properties.GIAC_CONTENT.properties.icon.default = _info.default.icon;
var _default = function _default() {
  return Object.assign({}, metas);
};
exports.default = _default;