import React from 'react';
export declare type Language = 'zh-CN' | 'en-US';
export declare function getLocale(): Language;
export declare function setLocale(locale: any): void;
export declare const formatMessage: ({ id, ...restProps }: {
    [x: string]: any;
    id: any;
}, locale?: Language) => string;
interface FormattedMessageProps {
    id: string;
    locale?: Language;
    [key: string]: any;
}
export default class FormattedMessage extends React.Component<Readonly<FormattedMessageProps>> {
    static contextType: React.Context<import("@antv/graphin").GraphinContextType>;
    render(): string;
}
export {};
