"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = _interopRequireDefault(require("@antv/algorithm"));
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _utils = _interopRequireDefault(require("../utils"));
var _locale = _interopRequireWildcard(require("./locale"));
var _patternEditor = _interopRequireDefault(require("./patternEditor"));
var _patternPane = _interopRequireDefault(require("./patternPane"));
var _registerMeta = require("./registerMeta");
var _resultTable = _interopRequireDefault(require("./resultTable"));
var _util = require("./util");
require("./index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, defineProperty = Object.defineProperty || function (obj, key, desc) { obj[key] = desc.value; }, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return defineProperty(generator, "_invoke", { value: makeInvokeMethod(innerFn, self, context) }), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; defineProperty(this, "_invoke", { value: function value(method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), defineProperty(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (val) { var object = Object(val), keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, catch: function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * author:shiwu.wyy@antgroup.com
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var confirm = _antd.Modal.confirm;
var TabPane = _antd.Tabs.TabPane;
var GADDI = _algorithm.default.GADDI,
  breadthFirstSearch = _algorithm.default.breadthFirstSearch;
var createUuid = _utils.default.createUuid,
  clearItemsStates = _utils.default.clearItemsStates,
  fittingString = _utils.default.fittingString;
var MAX_PATTERN_NUM = 4;
var EXTRACT_MESSAGE_KEY = 'kg-pattern-match-extract-message';
var EXTRACT_MODE_CANVAS_CLASSNAME = 'kg-pattern-match-extract-mode-canvas';
var newTabIndex = 1;
var previousSize = {
  width: 500,
  height: 500
};
var keydown = false;
var PatternMatch = function PatternMatch(_ref) {
  var style = _ref.style,
    onClose = _ref.onClose,
    onOpen = _ref.onOpen,
    _ref$options = _ref.options,
    options = _ref$options === void 0 ? {} : _ref$options;
  var _a;
  var onGraphEditorVisibleChange = options.onGraphEditorVisibleChange,
    onExtractModeChange = options.onExtractModeChange,
    exportPattern = options.exportPattern,
    exportButton = options.exportButton;
  var _useContext = (0, _giSdk.useContext)(),
    graph = _useContext.graph,
    data = _useContext.data,
    schemaData = _useContext.schemaData;
  var _useState = (0, _react.useState)('1'),
    _useState2 = _slicedToArray(_useState, 2),
    activeKey = _useState2[0],
    setActiveKey = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    editorVisible = _useState4[0],
    setEditorVisible = _useState4[1];
  var _useState5 = (0, _react.useState)([]),
    _useState6 = _slicedToArray(_useState5, 2),
    result = _useState6[0],
    setResult = _useState6[1];
  var _useState7 = (0, _react.useState)([]),
    _useState8 = _slicedToArray(_useState7, 2),
    hullIds = _useState8[0],
    setHullIds = _useState8[1];
  var _useState9 = (0, _react.useState)(false),
    _useState10 = _slicedToArray(_useState9, 2),
    loading = _useState10[0],
    setLoading = _useState10[1];
  var _useState11 = (0, _react.useState)(false),
    _useState12 = _slicedToArray(_useState11, 2),
    extracting = _useState12[0],
    setExtracting = _useState12[1];
  // 数据结构 { [nodeType: string]: Set }
  var _useState13 = (0, _react.useState)({}),
    _useState14 = _slicedToArray(_useState13, 2),
    nodeProperties = _useState14[0],
    setNodeProperties = _useState14[1];
  // 数据结构 { [edgeType: string]: Set }
  var _useState15 = (0, _react.useState)({}),
    _useState16 = _slicedToArray(_useState15, 2),
    edgeProperties = _useState16[0],
    setEdgeProperties = _useState16[1];
  var _useState17 = (0, _react.useState)([]),
    _useState18 = _slicedToArray(_useState17, 2),
    nodeTypes = _useState18[0],
    setNodeTypes = _useState18[1];
  var _useState19 = (0, _react.useState)([]),
    _useState20 = _slicedToArray(_useState19, 2),
    edgeTypes = _useState20[0],
    setEdgeTypes = _useState20[1];
  var _useState21 = (0, _react.useState)({}),
    _useState22 = _slicedToArray(_useState21, 2),
    schemaEdgeMap = _useState22[0],
    setSchemaEdgeMap = _useState22[1];
  var _useState23 = (0, _react.useState)({}),
    _useState24 = _slicedToArray(_useState23, 2),
    schemaNodeMap = _useState24[0],
    setSchemaNodeMap = _useState24[1];
  var intialPatternInfoMap = (0, _react.useMemo)(function () {
    return {
      '1': {
        id: '1',
        title: /*#__PURE__*/_react.default.createElement(_locale.default, {
          id: "pattern-title",
          value: '1'
        }),
        data: null
      }
    };
  }, []);
  var _useState25 = (0, _react.useState)(intialPatternInfoMap),
    _useState26 = _slicedToArray(_useState25, 2),
    patternInfoMap = _useState26[0],
    setPatternInfoMap = _useState26[1];
  var importData = function importData(data, patternId) {
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    newPatternInfoMap[patternId].data = data;
    setPatternInfoMap(newPatternInfoMap);
  };
  var _useState27 = (0, _react.useState)(function () {
      return [{
        title: /*#__PURE__*/_react.default.createElement(_locale.default, {
          id: "pattern-title",
          value: intialPatternInfoMap['1'].id
        }),
        content: /*#__PURE__*/_react.default.createElement(_patternPane.default, Object.assign({}, intialPatternInfoMap['1'], {
          schemaEdgeMap: schemaEdgeMap,
          editPattern: function editPattern() {
            return setEditorVisible(true);
          },
          importData: importData
        })),
        key: intialPatternInfoMap['1'].id
      }];
    }),
    _useState28 = _slicedToArray(_useState27, 2),
    panes = _useState28[0],
    setPanes = _useState28[1];
  (0, _react.useEffect)(function () {
    var sEdgeMap = {};
    var sNodeMap = {};
    schemaData.edges.forEach(function (schemaEdge) {
      return sEdgeMap[schemaEdge.edgeType] = schemaEdge;
    });
    schemaData.nodes.forEach(function (schemaNode) {
      return sNodeMap[schemaNode.nodeType] = schemaNode;
    });
    // 数据结构 { [nodeType: string]: Set }
    var nodeTypeProperties = {};
    data.nodes.forEach(function (node) {
      nodeTypeProperties[node.nodeType] = nodeTypeProperties[node.nodeType] || new Set();
      Object.keys(node.data).forEach(function (key) {
        return nodeTypeProperties[node.nodeType].add(key);
      });
    });
    var nTypes = Object.keys(nodeTypeProperties).map(function (key) {
      var fittedText = fittingString(key, 280, 14);
      return {
        key: key,
        text: key,
        content: /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
          title: (fittedText === null || fittedText === void 0 ? void 0 : fittedText.includes('…')) ? key : ''
        }, fittedText)
      };
    });
    // 数据结构 { [edgeType: string]: Set }
    var edgeTypeProperties = {};
    data.edges.forEach(function (edge) {
      var edgeType = edge.edgeType;
      var schema = sEdgeMap[edgeType] || {};
      var sourceNodeType = schema.sourceNodeType,
        targetNodeType = schema.targetNodeType;
      var spo = "".concat(sourceNodeType).concat(_registerMeta.SPLITOR).concat(edgeType).concat(_registerMeta.SPLITOR).concat(targetNodeType);
      edgeTypeProperties[spo] = edgeTypeProperties[spo] || new Set();
      Object.keys(edge.data).forEach(function (key) {
        return edgeTypeProperties[spo].add(key);
      });
    });
    var eTypes = Object.keys(edgeTypeProperties).map(function (key) {
      var _key$split = key.split(_registerMeta.SPLITOR),
        _key$split2 = _slicedToArray(_key$split, 3),
        sourceNodeType = _key$split2[0],
        typeName = _key$split2[1],
        targetNodeType = _key$split2[2];
      var subText = "".concat(sourceNodeType, " \u2192 ").concat(targetNodeType);
      var fittedText = fittingString(typeName, 280, 14);
      var fittedSubText = fittingString(subText, 280, 14);
      return {
        key: key,
        typeName: typeName,
        sourceNodeType: sourceNodeType,
        targetNodeType: targetNodeType,
        content: /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
          title: (fittedText === null || fittedText === void 0 ? void 0 : fittedText.includes('…')) || (fittedSubText === null || fittedSubText === void 0 ? void 0 : fittedSubText.includes('…')) ? "".concat(typeName, " (").concat(subText, ")") : ''
        }, fittedText, /*#__PURE__*/_react.default.createElement("p", {
          className: "kg-node-importance-tip"
        }, fittedSubText))
      };
    });
    setSchemaEdgeMap(sEdgeMap);
    setSchemaNodeMap(sNodeMap);
    setNodeProperties(nodeTypeProperties);
    setEdgeProperties(edgeTypeProperties);
    setNodeTypes(nTypes);
    setEdgeTypes(eTypes);
  }, [data]);
  // 编辑器的显示抛出回调
  (0, _react.useEffect)(function () {
    return onGraphEditorVisibleChange === null || onGraphEditorVisibleChange === void 0 ? void 0 : onGraphEditorVisibleChange(editorVisible);
  }, [editorVisible]);
  // 模式编辑完成后，patternInfoMap 发生变化，触发模式 tabs 中显示的内容变化
  (0, _react.useEffect)(function () {
    var newPanes = panes.map(function (pane) {
      var _a;
      return Object.assign(Object.assign({}, pane), {
        content: /*#__PURE__*/_react.default.createElement(_patternPane.default, {
          id: pane.key,
          data: (_a = patternInfoMap[pane.key]) === null || _a === void 0 ? void 0 : _a.data,
          schemaEdgeMap: schemaEdgeMap,
          editPattern: function editPattern() {
            return setEditorVisible(true);
          },
          extractPattern: enableExtractingMode,
          importData: importData
        })
      });
    });
    setPanes(newPanes);
  }, [patternInfoMap]);
  var enableExtractingMode = function enableExtractingMode(patternId) {
    if (!graph || graph.destroyed) return;
    previousSize = {
      width: graph.getWidth(),
      height: graph.getHeight()
    };
    _antd.message.info({
      key: EXTRACT_MESSAGE_KEY,
      className: 'kg-pattern-match-extract-tip-long',
      duration: 0,
      content: (0, _locale.formatMessage)({
        id: 'extract-pattern-tip-long'
      }),
      style: {
        marginTop: '20px'
      }
    });
    graph.setMode('pattern-match-lasso'); // 切换为 lasso 交互模式，该模式下没有其他 behavior
    // 恢复图上的选中状态，为拉索框选做准备
    clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Selected]);
    clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Selected]);
    setExtracting(patternId);
    onClose === null || onClose === void 0 ? void 0 : onClose(); // 隐藏抽屉;
    onExtractModeChange === null || onExtractModeChange === void 0 ? void 0 : onExtractModeChange(true);
    // 设置 canvas dom 描边样式
    setCanvasDomStyle(true);
  };
  var quitExtractMode = function quitExtractMode() {
    graph.setMode('default'); // 恢复默认交互模式
    _antd.message.destroy(EXTRACT_MESSAGE_KEY); // 销毁提示 message
    setExtracting(false); // 恢复面板状态
    onOpen === null || onOpen === void 0 ? void 0 : onOpen(); // 显示抽屉
    setExtracting(false); // 恢复面板状态
    onExtractModeChange === null || onExtractModeChange === void 0 ? void 0 : onExtractModeChange(false);
    // 设置 canvas dom 描边样式
    setCanvasDomStyle(false);
  };
  var extractPattern = function extractPattern() {
    if (!graph || graph.destroyed) {
      quitExtractMode();
      return;
    }
    if (!extracting) return;
    var patternId = extracting;
    var nodes = graph.findAllByState('node', _registerMeta.ITEM_STATE.Selected) || [];
    var edges = graph.findAllByState('edge', _registerMeta.ITEM_STATE.Selected) || [];
    if (!nodes.length) return;
    // 验证当前模式图是连通的
    var data = {
      nodes: nodes.map(function (node) {
        return node.getModel();
      }),
      edges: edges.map(function (edge) {
        return edge.getModel();
      })
    };
    var traversedTag = {};
    breadthFirstSearch(data, data.nodes[0].id, {
      enter: function enter(_ref2) {
        var current = _ref2.current;
        traversedTag[current] = true;
      }
    }, false);
    if (Object.keys(traversedTag).length < data.nodes.length) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'save-failed-must-connected'
      }));
      return;
    }
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    // 抽取成模式
    var newIdMap = {};
    var pattern = {
      nodes: [],
      edges: []
    };
    data.nodes.forEach(function (node, i) {
      var nodeData = node.data,
        dataId = node.id;
      var schema = schemaData.nodes.find(function (item) {
        return item.nodeType === nodeData.nodeType;
      });
      var _ref3 = schema || {},
        _ref3$nodeType = _ref3.nodeType,
        nodeType = _ref3$nodeType === void 0 ? nodeData.nodeType : _ref3$nodeType;
      var id = createUuid();
      newIdMap[dataId] = {
        id: id,
        nodeType: nodeType
      };
      pattern.nodes.push({
        id: id,
        oriId: dataId,
        cluster: undefined,
        rules: undefined,
        nodeType: nodeType,
        style: {
          label: {
            value: "".concat(nodeType, "-").concat(pattern.nodes.length)
          }
        },
        originLabel: "".concat(nodeType, "-").concat(pattern.nodes.length),
        data: {
          id: id,
          nodeType: nodeType
        }
      });
    });
    // 抽取边的同时，验证当前模式图中所有边的端点都在 nodes 中
    var invalid = false;
    var _loop = function _loop(i) {
      var edge = data.edges[i];
      var dataId = edge.id,
        dataSource = edge.source,
        dataTarget = edge.target,
        edgeData = edge.data;
      var schema = schemaData.edges.find(function (item) {
        return item.edgeType === edgeData.edgeType;
      });
      var _ref4 = schema || {},
        _ref4$edgeType = _ref4.edgeType,
        edgeType = _ref4$edgeType === void 0 ? edgeData.edgeType : _ref4$edgeType;
      if (!newIdMap[dataSource] || !newIdMap[dataTarget]) {
        invalid = true;
        return "break";
      }
      var _newIdMap$dataSource = newIdMap[dataSource],
        source = _newIdMap$dataSource.id,
        sourceNodeType = _newIdMap$dataSource.nodeType;
      var _newIdMap$dataTarget = newIdMap[dataTarget],
        target = _newIdMap$dataTarget.id,
        targetNodeType = _newIdMap$dataTarget.nodeType;
      pattern.edges.push({
        id: "".concat(source, "-").concat(target, "-").concat(createUuid()),
        oriId: dataId,
        source: source,
        target: target,
        rules: [],
        type: source === target ? 'loop' : 'graphin-line',
        loopCfg: {
          position: 'top',
          dist: source === target ? 25 : 20
        },
        style: {
          label: {
            value: "".concat(edgeType, "-").concat(pattern.edges.length)
          }
        },
        label: "".concat(edgeType, "-").concat(pattern.edges.length),
        labelCfg: {
          autoRotate: true
        },
        edgeType: edgeType,
        sourceNodeType: sourceNodeType,
        targetNodeType: targetNodeType
      });
    };
    for (var i = 0; i < data.edges.length; i++) {
      var _ret = _loop(i);
      if (_ret === "break") break;
    }
    if (invalid) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'save-failed-edge-must-have-nodes'
      }));
      return;
    }
    newPatternInfoMap[patternId].data = pattern;
    setPatternInfoMap(newPatternInfoMap); // 放入模式编辑器中
    quitExtractMode();
  };
  var cancelExtracting = function cancelExtracting() {
    setExtracting(false);
    if (!graph || graph.destroyed) return;
    // 如果有选中的内容，退出需要二次提示
    var selectedNodes = graph.findAllByState('node', _registerMeta.ITEM_STATE.Selected);
    var selectedEdges = graph.findAllByState('node', _registerMeta.ITEM_STATE.Selected);
    if ((selectedNodes === null || selectedNodes === void 0 ? void 0 : selectedNodes.length) || (selectedEdges === null || selectedEdges === void 0 ? void 0 : selectedEdges.length)) {
      confirm({
        title: (0, _locale.formatMessage)({
          id: 'extract-confirm-cancel'
        }),
        icon: /*#__PURE__*/_react.default.createElement(_icons.ExclamationCircleOutlined, null),
        content: (0, _locale.formatMessage)({
          id: 'extract-confirm-cancel-content'
        }),
        onOk: function onOk() {
          clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Selected]);
          clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Selected]);
          graph.setMode('default');
          _antd.message.destroy(EXTRACT_MESSAGE_KEY);
          onOpen === null || onOpen === void 0 ? void 0 : onOpen(); // 显示抽屉
          quitExtractMode();
        }
      });
    } else {
      graph.setMode('default');
      _antd.message.destroy(EXTRACT_MESSAGE_KEY);
      onOpen === null || onOpen === void 0 ? void 0 : onOpen(); // 显示抽屉
      quitExtractMode();
    }
  };
  // 为 graph 绑定元素更新监听，更新 hulll
  var updateHull = function updateHull(e) {
    var _a, _b;
    if (!graph || graph.destroyed) return;
    var id = ((_b = (_a = e === null || e === void 0 ? void 0 : e.item) === null || _a === void 0 ? void 0 : _a.getType) === null || _b === void 0 ? void 0 : _b.call(_a)) === 'node' ? e.item.getID() : undefined;
    var hulls = graph.getHulls();
    if (!hulls) return;
    var foundHullKeys = [];
    Object.keys(hulls).forEach(function (key) {
      var _a;
      var hull = hulls[key];
      if (id === undefined) foundHullKeys.push(key);else if ((_a = hull === null || hull === void 0 ? void 0 : hull.members) === null || _a === void 0 ? void 0 : _a.find(function (node) {
        var _a;
        return ((_a = node.getID) === null || _a === void 0 ? void 0 : _a.call(node)) === id;
      })) foundHullKeys.push(key);
    });
    foundHullKeys.forEach(function (key) {
      return hulls[key].updateData(hulls[key].members, []);
    });
  };
  var removeHulls = function removeHulls() {
    setHullIds(function (ids) {
      var hullMap = graph.get('hullMap') || {};
      ids === null || ids === void 0 ? void 0 : ids.forEach(function (hullId) {
        var hull = graph.getHullById(hullId);
        if (hull) graph.removeHull(hull);
        delete hullMap[hullId];
      });
      return [];
    });
  };
  var handleKeydown = function handleKeydown(e) {
    var code = e.key;
    if (!code) return;
    if (code.toLowerCase() === 'w') keydown = true;else keydown = false;
  };
  var handleKeyup = function handleKeyup(e) {
    return keydown = false;
  };
  // tab 切换，取消图上的选中状态
  (0, _react.useEffect)(function () {
    if (graph && !graph.destroyed) {
      clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Selected]);
      clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Selected]);
    }
  }, [activeKey]);
  (0, _react.useEffect)(function () {
    _antd.message.destroy(EXTRACT_MESSAGE_KEY); // 销毁提示 message
    if (!graph || graph.destroyed) return;
    graph.addBehaviors([{
      type: 'lasso-select',
      trigger: 'drag',
      shouldDeselect: function shouldDeselect() {
        return false;
      }
    }, 'click-select', 'zoom-canvas', {
      type: 'drag-canvas',
      shouldBegin: function shouldBegin() {
        return keydown;
      }
    }], 'pattern-match-lasso');
    graph.on('afterupdateitem', updateHull);
    graph.on('afterlayout', updateHull);
    graph.on('graphin:datachange', removeHulls);
    graph.on('node:toggleevent', removeHulls);
    graph.on('sizechange', updateDomSize);
    graph.on('keydown', handleKeydown);
    graph.on('keyup', handleKeyup);
    return function () {
      _antd.message.destroy(EXTRACT_MESSAGE_KEY); // 销毁提示 message
      if (graph && !graph.destroyed) {
        setCanvasDomStyle(false);
        graph.off('afterudpateitem', updateHull);
        graph.off('afterlayout', updateHull);
        graph.off('graphin:datachange', removeHulls);
        graph.off('node:toggleevent', removeHulls);
        graph.off('sizechange', updateDomSize);
        graph.off('keydown', handleKeydown);
        graph.off('keyup', handleKeyup);
      }
    };
  }, []);
  /** 浏览器宽高改变时，在抽取状态下需要更新画布宽高以便显示画布外边框 */
  var updateDomSize = function updateDomSize(_ref5) {
    var width = _ref5.width,
      height = _ref5.height;
    previousSize = {
      width: width,
      height: height
    };
    var canvasDOM = graph.get('canvas').get('el');
    if (canvasDOM.classList.contains(EXTRACT_MODE_CANVAS_CLASSNAME)) {
      setTimeout(function () {
        graph.changeSize(width - 32, height - 32);
      }, 151);
    } else if (width !== graph.getWidth() || height !== graph.getHeight()) {
      graph.changeSize(width, height);
    }
  };
  var setCanvasDomStyle = function setCanvasDomStyle(extractMode) {
    var canvasDOM = graph.get('canvas').get('el');
    if (extractMode) {
      graph.changeSize(previousSize.width - 32, previousSize.height - 32);
      canvasDOM.classList.add(EXTRACT_MODE_CANVAS_CLASSNAME);
    } else {
      var _previousSize = previousSize,
        width = _previousSize.width,
        height = _previousSize.height;
      graph.changeSize(width, height);
      canvasDOM.classList.remove(EXTRACT_MODE_CANVAS_CLASSNAME);
    }
  };
  var addTab = function addTab(copyItem) {
    var _a;
    if (panes.length > MAX_PATTERN_NUM - 1) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'pattern-num-limit'
      }));
      return;
    }
    newTabIndex += 1;
    var id = "".concat(newTabIndex);
    var newPanes = _toConsumableArray(panes);
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    newPatternInfoMap[id] = {
      id: id,
      title: /*#__PURE__*/_react.default.createElement(_locale.default, {
        id: "pattern-title",
        value: id
      }),
      data: null
    };
    if (copyItem && ((_a = patternInfoMap[copyItem.key]) === null || _a === void 0 ? void 0 : _a.data)) {
      newPatternInfoMap[id].data = (0, _lodash.cloneDeep)(patternInfoMap[copyItem.key].data);
    }
    newPanes.push({
      content: /*#__PURE__*/_react.default.createElement(_patternPane.default, {
        id: id,
        data: newPatternInfoMap[id],
        schemaEdgeMap: schemaEdgeMap,
        editPattern: function editPattern() {
          return setEditorVisible(true);
        },
        importData: importData
      }),
      title: /*#__PURE__*/_react.default.createElement(_locale.default, {
        id: "pattern-title",
        value: id
      }),
      key: id
    });
    setPanes(newPanes);
    setPatternInfoMap(newPatternInfoMap);
    setActiveKey(id);
  };
  var removeTab = function removeTab(key) {
    var newActiveKey = activeKey;
    var lastIndex;
    panes.forEach(function (pane, i) {
      if (pane.key === key) {
        lastIndex = i - 1;
      }
    });
    var newPanes = panes.filter(function (pane) {
      return pane.key !== key;
    });
    if (newPanes.length && newActiveKey === key) {
      if (lastIndex >= 0) {
        newActiveKey = newPanes[lastIndex].key;
      } else {
        newActiveKey = newPanes[0].key;
      }
    }
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    delete newPatternInfoMap[key];
    setActiveKey(newActiveKey);
    setPatternInfoMap(newPatternInfoMap);
    setPanes(newPanes);
  };
  var onTabEdit = function onTabEdit(targetKey, action) {
    if (action === 'remove') removeTab(targetKey);
  };
  var drawHulls = function drawHulls(matches) {
    removeHulls();
    var ids = [];
    matches.forEach(function (match) {
      var _a;
      var hullId = createUuid();
      ids.push(hullId);
      match.hullId = hullId;
      graph.createHull({
        id: hullId,
        members: (_a = match.nodes) === null || _a === void 0 ? void 0 : _a.map(function (node) {
          return node.id;
        }),
        padding: 10
      });
    });
    setHullIds(ids);
  };
  var onMatch = function onMatch() {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var _b, res, pattern, graphData, directed, matches;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!graph || graph.destroyed)) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return");
            case 2:
              if (!(!activeKey || !((_b = patternInfoMap[+activeKey]) === null || _b === void 0 ? void 0 : _b.data))) {
                _context.next = 5;
                break;
              }
              _antd.message.info((0, _locale.formatMessage)({
                id: 'cannot-match-empty-pattern'
              }));
              return _context.abrupt("return");
            case 5:
              res = patternInfoMap[+activeKey].data;
              pattern = {
                nodes: res.nodes.map(function (node) {
                  return {
                    id: node.id,
                    label: node.nodeType,
                    name: node.nodeType,
                    rules: node.rules
                  };
                }),
                edges: res.edges.map(function (edge) {
                  return {
                    id: edge.id,
                    label: edge.edgeType,
                    source: edge.source,
                    target: edge.target,
                    rules: edge.rules
                  };
                })
              };
              graphData = {
                nodes: [],
                edges: []
              };
              data.nodes.forEach(function (node) {
                var _a;
                if (!((_a = graph.findById(node.id)) === null || _a === void 0 ? void 0 : _a.isVisible())) return;
                graphData.nodes.push({
                  id: node.id,
                  data: node.data,
                  label: node.nodeType
                });
              });
              data.edges.forEach(function (edge) {
                var _a;
                if (!((_a = graph.findById(edge.id)) === null || _a === void 0 ? void 0 : _a.isVisible())) return;
                graphData.edges.push({
                  id: edge.id,
                  data: edge.data,
                  source: edge.source,
                  target: edge.target,
                  label: edge.edgeType
                });
              });
              // 计算模式匹配结果
              setLoading(true);
              directed = true;
              matches = [];
              _context.prev = 13;
              _context.next = 16;
              return GADDI(graphData, pattern, directed, undefined, undefined, 'label', 'label');
            case 16:
              matches = _context.sent;
              _context.next = 22;
              break;
            case 19:
              _context.prev = 19;
              _context.t0 = _context["catch"](13);
              console.warn('Pattern Matching Failed.', _context.t0);
            case 22:
              if (matches === null || matches === void 0 ? void 0 : matches.length) {
                _context.next = 28;
                break;
              }
              _antd.message.info((0, _locale.formatMessage)({
                id: 'no-result'
              }));
              setLoading(false);
              drawHulls([]);
              setResult([]);
              return _context.abrupt("return");
            case 28:
              // 对结果 matches 进行 rules 的筛选
              (0, _util.filterByPatternRules)(graphData, pattern, matches, directed);
              // 进行 rules 筛选之后，若 matches 被删空了，提示没找到匹配
              if (!(matches === null || matches === void 0 ? void 0 : matches.length)) {
                _antd.message.info((0, _locale.formatMessage)({
                  id: 'no-result'
                }));
              }
              setLoading(false);
              drawHulls(matches);
              setResult(matches);
            case 33:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[13, 19]]);
    }));
  };
  var onExport = function onExport() {
    var _a;
    if (!graph || graph.destroyed) return;
    if (!activeKey || !((_a = patternInfoMap[+activeKey]) === null || _a === void 0 ? void 0 : _a.data)) {
      _antd.message.info((0, _locale.formatMessage)({
        id: 'cannot-match-empty-pattern'
      }));
      return;
    }
    var res = patternInfoMap[+activeKey].data;
    var pattern = {
      nodes: res.nodes.map(function (node) {
        node.data.label = node.nodeType;
        node.data.rules = node.rules;
        return node.data;
      }),
      edges: res.edges.map(function (edge) {
        edge.data.label = edge.nodeType;
        edge.data.rules = edge.rules;
        return edge.data;
      })
    };
    exportPattern === null || exportPattern === void 0 ? void 0 : exportPattern(pattern);
  };
  var savePattern = function savePattern(id, saveData) {
    var newPatternInfoMap = Object.assign({}, patternInfoMap);
    if (!newPatternInfoMap[id]) {
      newPatternInfoMap[id] = {
        id: id,
        title: /*#__PURE__*/_react.default.createElement(_locale.default, {
          id: "pattern-title",
          value: id
        })
      };
    }
    newPatternInfoMap[id].data = saveData;
    setPatternInfoMap(newPatternInfoMap);
  };
  var reset = function reset() {
    clearItemsStates(graph, graph.getEdges(), [_registerMeta.ITEM_STATE.Selected]);
    clearItemsStates(graph, graph.getNodes(), [_registerMeta.ITEM_STATE.Selected]);
    removeHulls();
    setResult([]);
  };
  var patternTabsMenu = /*#__PURE__*/_react.default.createElement(_antd.Menu, {
    className: "kg-pattern-match-patten-tab-dropdown"
  }, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    key: "new",
    onClick: addTab
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "new-pattern"
  })), panes === null || panes === void 0 ? void 0 : panes.map(function (item) {
    return /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: item.key,
      onClick: function onClick() {
        return addTab(item);
      }
    }, /*#__PURE__*/_react.default.createElement(_locale.default, {
      id: "clone-title",
      value: item.key
    }));
  }));
  // 组件挂载时，获取 Canvas 的父元素，用于通过 Portal 放置额外按钮。
  var _useState29 = (0, _react.useState)(),
    _useState30 = _slicedToArray(_useState29, 2),
    extraButtonsContainer = _useState30[0],
    setExtraButtonsContainer = _useState30[1];
  (0, _react.useEffect)(function () {
    var canvasDOM = graph.get('canvas').get('el');
    var parentDOM = canvasDOM.parentNode;
    var container = document.createElement('div');
    parentDOM === null || parentDOM === void 0 ? void 0 : parentDOM.appendChild(container);
    setExtraButtonsContainer(container);
    return function () {
      var _a;
      (_a = container.parentNode) === null || _a === void 0 ? void 0 : _a.removeChild(container);
    };
  }, []);
  var buttonsPortal = extracting && extraButtonsContainer && /*#__PURE__*/_reactDom.default.createPortal( /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-extract-buttons"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    onClick: cancelExtracting
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "cancel"
  })), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "primary",
    onClick: extractPattern
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "confirm"
  }))), extraButtonsContainer);
  return /*#__PURE__*/_react.default.createElement("div", {
    style: style
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-content-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-pattern-add-wrapper",
    style: {
      left: panes.length === 1 ? 79 : 106 + (panes.length - 1) * 108,
      display: panes.length > MAX_PATTERN_NUM - 1 ? 'none' : 'block'
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: patternTabsMenu,
    placement: "bottomCenter"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-match-pattern-add",
    onClick: addTab
  }, "+"))), /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    type: "editable-card",
    activeKey: "".concat(activeKey),
    onChange: setActiveKey,
    onEdit: onTabEdit,
    hideAdd: true,
    style: {
      marginTop: panes.length > MAX_PATTERN_NUM - 1 ? '-4px' : '-40px'
    }
  }, panes.map(function (pane) {
    return /*#__PURE__*/_react.default.createElement(TabPane, {
      tab: pane.title,
      key: pane.key,
      closable: panes.length > 1
    }, pane.content);
  }))), /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "button-wrapper",
    justify: "space-between"
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 6
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-apply-button",
    style: {
      display: extracting ? 'none' : 'inline-block'
    },
    type: "primary",
    loading: loading,
    onClick: onMatch
  }, /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "match"
  }))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 6
  }, ((_a = patternInfoMap[+activeKey]) === null || _a === void 0 ? void 0 : _a.data) ? /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-export-button",
    style: Object.assign(Object.assign({}, (exportButton === null || exportButton === void 0 ? void 0 : exportButton.style) || {}), {
      display: extracting ? 'none' : 'inline-block'
    }),
    loading: loading,
    disabled: !!extracting,
    onClick: onExport
  }, (exportButton === null || exportButton === void 0 ? void 0 : exportButton.text) || /*#__PURE__*/_react.default.createElement(_locale.default, {
    id: "export-pattern"
  })) : ''), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 4,
    offset: 6
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "kg-pattern-match-reset-button",
    danger: true,
    onClick: reset,
    icon: /*#__PURE__*/_react.default.createElement(_icons.DeleteOutlined, null)
  }))), (result === null || result === void 0 ? void 0 : result.length) && !extracting ? /*#__PURE__*/_react.default.createElement(_resultTable.default, {
    matches: result
  }) : '', /*#__PURE__*/_react.default.createElement(_patternEditor.default, {
    visible: editorVisible,
    patternInfo: patternInfoMap[activeKey],
    setVisible: setEditorVisible,
    savePattern: savePattern,
    nodeProperties: nodeProperties,
    edgeProperties: edgeProperties,
    nodeTypes: nodeTypes,
    edgeTypes: edgeTypes,
    schemaNodeMap: schemaNodeMap,
    schemaEdgeMap: schemaEdgeMap
  }), buttonsPortal);
};
var _default = PatternMatch;
exports.default = _default;