import { GIConfig, IEdgeSchema } from '@antv/gi-sdk';
import { GraphinData } from '@antv/graphin';
export declare const filterByPatternRules: (oriGraphData: GraphinData, pattern: any, matches: any, directed: any) => void;
export declare const formatDataModels: (dataType: 'node' | 'edge', models: any, config: GIConfig, schemaEdgeMap?: {
    [key: string]: IEdgeSchema;
}) => any;
export declare const formatData: (graphData: any, config: any, schemaEdgeMap: any) => GraphinData;
declare const _default: {
    filterByPatternRules: (oriGraphData: GraphinData, pattern: any, matches: any, directed: any) => void;
    formatDataModels: (dataType: "node" | "edge", models: any, config: GIConfig, schemaEdgeMap?: {
        [key: string]: IEdgeSchema;
    }) => any;
    formatData: (graphData: any, config: any, schemaEdgeMap: any) => GraphinData;
};
export default _default;
